% M_t generator

% ONLY for 3 stage model!!
if piecewise && ~prins_comp
    
par = load('R/progpar.txt');                   % loads spot parameters
                                               % row 1 = AR1, row 2 = AR2,
                                               % row 3 = MA1, row 5 = mean.
init_prog   = load('R/progdata.txt');          % Initial data
prog_err    = load('R/progres.txt');           % Residuals prognosis error
                                               
c_t = -par(5) - par(1)*init_prog(end) - par(2)*init_prog(end-1)...
      -par(3)*prog_err(end);         % c_1
c_t = -par(2)*init_prog(end) - par(3)*c_t - par(5);         % c_2

for t = 3:24
    c_t = -par(3)*c_t - par(5);
end     % obtains c_24

Stages = 3;    % OBS MANUAL :P - only 3 stage model
M_t = cell(Stages,1);
mean_spot = mean(spot(:,1:24));
M_t{1} = mean(xi)';
M_t{2} = eye(ks(2));
M2_add = zeros(1,ks(2));
M2_add(1) = par(5) + par(3)*c_t;

r_i_start = 1;
for t = 2:25     % start i for spot price hour t
    r_i_start(t) = r_i_start(t-1) + r_i(t-1);
end

for i = 3:24
    t = 25 - i;
    M2_add(r_i_start(t)+1:r_i_start(t+1)) = (-1)^i*par(3)^(i-3)*(par(2)-par(3)*(par(1)+par(3)));
end
t = 23;
M2_add(r_i_start(t)+1:r_i_start(t+1)) = par(2) - par(3)*(par(1)+par(3));
t = 24;
M2_add(r_i_start(t)+1:r_i_start(t+1)) = par(1)+par(3);
M_t{2} = [M_t{2};M2_add];

M_t{3} = eye(k);

else
    warning('M_t not generated, because piecewise is not used');
end